unit PSXTex;

interface

Uses Windows, SysUtils, Classes, Graphics, Dialogs, Cappo;

Type
  PWord = ^Word;
  PByte = ^Byte;
  PLong = ^Longint;

function ReadTex(Tex:TStream;DataOffset:Integer): TBitmap;

Const
  DATA_FF7 = $EC;
  DATA_STD = $F0;

implementation

function ReadTex(Tex:TStream;DataOffset:Integer): TBitmap;
var
I,J,X,Y,C:  Integer;
WTmp:       Word;
//WTmp:       Integer;
S1:         PWord;
Line1:      PWord;
Scan:       PByte;
Pal:        TMaxLogPalette;
FalsePal:   PLogPalette;
begin
Result := TBitmap.Create;
Tex.Position := $3C;
Tex.ReadBuffer(X,4);
Tex.ReadBuffer(Y,4);

Tex.Position := $58;
Tex.ReadBuffer(C,4);

Tex.Position := DataOffset;

Case C of
0:  begin //hicolor
//      Result.PixelFormat := pf32Bit;
      Result.PixelFormat := pf15Bit;
      Result.Width := X; Result.Height := Y;
      GetMem(Scan,X*Y*2);
      Tex.ReadBuffer(Scan^,X*Y*2);
      S1 := PWord(Scan);
      For I := 1 to Y do begin
        Line1 := Result.ScanLine[I-1];
        For J := 1 to X do begin
{          WTmp := Trunc(((S1^ or $7C00) shr 10)*255/31);
          WTmp := WTmp or (Trunc((S1^ or $1F)*255/31) shl 16);
          WTmp := WTmp or (Trunc(((S1^ or $3E0) shr 5)*255/31) shl 8);
          WTmp := WTmp or $00000000; }
{          WTmp := 0;
          WTmp := WTmp or ((S1^ or $1F) shl 10);
          WTmp := WTmp or ((S1^ or $3E0));
          WTmp := WTmp or (S1^ or $7C00) shr 10;}
          WTmp := S1^;
          Line1^ := WTmp;
//          Result.Canvas.Pixels[J-1,I-1] := WTmp;
          Inc(Line1); Inc(S1);
        end;
      end;
      FreeMem(Scan);
    end;
Else begin //paletted
    Result.PixelFormat := pf8Bit;
    Result.Width := X; Result.Height := Y;

    Pal.palVersion := $300;
    Pal.palNumEntries := C;
    Tex.ReadBuffer(Pal.palPalEntry,4*C);

    For I := 0 to 255 do begin
      Pal.palPalEntry[I].peFlags := 0;
      WTmp := Pal.palPalEntry[I].peRed;
      Pal.palPalEntry[I].peRed := Pal.palPalEntry[I].peBlue;
      Pal.palPalEntry[I].peBlue := WTmp;
{      Pal.palPalEntry[I].peBlue := 255-Pal.palPalEntry[I].peBlue;
      Pal.palPalEntry[I].peRed := 255-Pal.palPalEntry[I].peRed;
      Pal.palPalEntry[I].peGreen := 255-Pal.palPalEntry[I].peGreen;
      If I=0 then begin
        Pal.palPalEntry[I].peRed := 255;
        Pal.palPalEntry[I].peBlue := 255;
        Pal.palPalEntry[I].peGreen := 255;
      end;}
    end;

    FalsePal := @Pal;
    Result.Palette := CreatePalette(FalsePal^);
//    Tex.Position := Tex.Position-1;
    For I := 1 to Y do begin
      Scan := Result.ScanLine[I-1];
      X := Min(X,Tex.Size-Tex.Position);
      Tex.ReadBuffer(Scan^,X);
    end;

    SelectPalette(Result.Canvas.Handle,Result.Palette,True);
    RealizePalette(Result.Canvas.Handle);

end;
end;

end;

end.
